'''
Created on 5 june 2018

@author: Steven Fletcher - INRIA - Institut Pasteur - InBio
'''
import os
import scipy.io as sio
import MicroMator.DataManagement.frame_structure as frame_structure
from MicroMator.FileManagement import logger

MODULE = 'CellStar_DataExtractor'

class CellstarDataExtractor():
    '''this Class regroups all the methods that extract the output of CellStar'''
    def __init__(self, analysis_path, positions_object, brightfield):
        '''Args:
            analysis_path(str): the path of the acquired images
            positions_object(object): the AllPositions object generated by the MMwrapper.scripting module
            brightfield(string): the name of the brightfield channel
        '''
        self.analysis_path = analysis_path
        self.positions_object = positions_object
        self.brightfield = brightfield

    def get_cellstar_segment(self, frame, position):
        '''loads the segmentation .mat generated from CellStar
        Args:
            frame(int): current frame of the acquistion
            position(int): current analyzed position
        '''
        segmentmat_path = os.path.join(self.analysis_path, 'segments{}'.format(position), 'img_{}_{}_segmentation.mat'.format(frame, self.brightfield))
        segmentmat = sio.loadmat(segmentmat_path)
        logger('loaded cellstar segmentation output {}'.format(segmentmat_path), message_type='normal', print_=False, module=MODULE)
        return segmentmat

    def get_cellstar_tracking(self, position):
        '''loads the tracking .mat generated from CellStar and extracts the traces
        Args:
            position(int): current analyzed position
        '''
        trackmat_path = os.path.join(self.analysis_path, 'segments{}'.format(position), 'tracking', 'tracking.mat')
        trackmat = sio.loadmat(trackmat_path)
        trackmattraces = trackmat['tracking']['traces']
        logger('loaded cellstar tracking output {}'.format(trackmat_path), message_type='normal', print_=False, module=MODULE)
        return trackmattraces[0][0]

    def fill_frame_structure(self, position, frame_object_list, segmentmat, track_table, fluochannels, protocol):
        '''this method fills the Frame structure
        Args:
            position(object): the position object
            frame_object_list(list of Frame objects): a list of all the instances of the frame objects the images are in
            segmentmat(array): structure that stores all the data from the segmentation
            track_table(matrix): the matrix that is outputed by the meta tracker
            fluochannels(list of str): the list of the fluochannels
            protocol(Protocol object): the protocol object that contains the information related to the experiement Acquisition loop when Image was taken
        '''
        #logger('extracting data from cellstar analysis of pos{}'.format(position.index))
        cell_population, avgfluo = self.cell_data_extractor(fluochannels, segmentmat)
        frame_object_list.list_images[position.index] = frame_object_list.update_image(position, protocol, track_table, cell_population, avgfluo)
        logger('finished analyzing image #:{}'.format(position.index), module=MODULE)

    def cell_data_extractor(self, fluochannels, segmentmat):
        '''this method extracts the wanted data from CellStar's output and puts it in wanted structure
        Args:
            fluochannels(list of str): list of the channel names
            segmentmat(array): structure that stores all the data from the segmentation
        '''
        if list(segmentmat['snakes']):
            cellnumber = len(segmentmat['snakes'][0])
            cells = []
            if fluochannels:
                fluo = segmentmat['fluorescence'][0][0][0] # matrix for fluo of each cell
                avgfluo = {}
                for channel_index in range(len(fluochannels)):
                    avgfluo[fluochannels[channel_index]] = sum(fluo[channel_index])/len(fluo[channel_index])
            else:
                avgfluo = 0
        else:
            cellnumber = 0
            avgfluo = 0
        cells = []
        for cellindex in range(cellnumber):
            snakes = segmentmat['snakes'][0]
            snakes_2 = snakes[cellindex]['seed'][0][0][0][0]
            coordinates = (snakes_2[0][0][0], snakes_2[1][0][0]) #seed coordinates
            if fluochannels:
                fluolevels = {}
                for channel_index in range(len(fluochannels)):
                    fluolevels[fluochannels[channel_index]] = fluo[channel_index][cellindex]
            else:
                fluolevels = None
            cells.append(frame_structure.Cell(tracknumber=cellindex, fluolevels=fluolevels, coordinates=coordinates))
        return cells, avgfluo
